/**
	Definitions for "hola" program
	(this use OpenGL primitives and Qt)

	Fraga 19/09/2001
	Fraga 23/10/2014
**/
#ifndef CANVAS_H
#define CANVAS_H

#include <QWidget>
#include <QtOpenGL>
#include <QTimer>

class Canvas: public QGLWidget
{
	Q_OBJECT  // must include this if you use Qt signals/slots
public:
	Canvas( QWidget *parent=0 );
	QSizePolicy sizePolicy() const;
	void getPosition ( int *x, int *y ) { *x = xmouse; *y = ymouse; }
	void getSize ( int *w, int *h ) { 
		*w = windowWidth; *h = windowHeight; 
	}
	void initCarasColor( void );
	void makeCheckBoardImage( void );

public slots:
	void timerDone( void );
	void initscreen( void ) { 
		timer->start(500);
	}
	void stop( void ) {
		timer->stop( );
 	} 

signals:
	void changePos( ); // called when mouse is moved
	void changeSize( ); // called when windows is resized
 
protected:
	void initializeGL( void );
	void resizeGL( int w, int h );
	void paintGL( void );
	void mouseMoveEvent( QMouseEvent * );
	void keyPressEvent ( QKeyEvent * e );
	// void mousePressEvent( QMouseEvent * );
 
 
private:
	#define IMGWIDTH  64
	#define IMGHEIGHT 64
	
	QTimer *timer;

	int windowWidth, windowHeight;   // canvas width and height

	float yrot, xrot;  // Encene rotation

	float angle;
	int signo;
	int xmouse, ymouse;  // Mouse pointer coordinates

	GLubyte checkImage[IMGHEIGHT][IMGWIDTH][4];
	GLuint texName;
};


#endif // CUBO_H
